/**HEADER********************************************************************
* 
* Copyright (c) 2010 Avnet Japan Co.,Ltd (NIKE Borad Project.)
* All Rights Reserved
*
*************************************************************************** 
*
* $FileName: mfs_Task.c$
* $Version : 3.0.5.0$
* $Date    : Nov-21-2008$
*
* Comments:
*
*   
*
*END************************************************************************/

#include "NIKE_demo.h"
#include "event.h"


/* ------------------------------------------------------------------ 
   --- macro definition                                           --- 
   ------------------------------------------------------------------ */

/* t@CTCY̍ő */
#define MFS_FILE_SIZE_MAX				(1024l*1024l*5)


/* ʒmCxg */
#define MC_EVENT_SET_OPEN				__BIT(0)
#define MC_EVENT_SET_CLOSE				__BIT(1)
#define MC_EVENT_SET_SIGNAL_DATA		__BIT(2)
#define MC_EVENT_GET_OPEN				__BIT(4)
#define MC_EVENT_GET_CLOSE				__BIT(5)
#define MC_EVENT_GET_SIGNAL_DATA		__BIT(6)


/* ^/Đ  */
#define MFS_CONTROL_MEM_MAXSIZE			8
#define MFS_CONTROL_DATA_SIZE			300*2


/* ^/Đ  */
#define MFS_CONTROL_FILE_CLOSE			0
#define MFS_CONTROL_FILE_NO				0
#define MFS_CONTROL_FILE_WRITE_ING		1
#define MFS_CONTROL_FILE_WRITE			2
#define MFS_CONTROL_FILE_READ			3


#define E_OK	0
#define E_OBJ	-1


/* ------------------------------------------------------------------ 
   --- structure body definition                                  --- 
   ------------------------------------------------------------------ */

/* 錾FMFS_CONTROL_MEM_DATA */
typedef struct
{
	uint_16	data[MFS_CONTROL_DATA_SIZE];
	uint_16	size;
}MFS_CONTROL_MEM_DATA, *PMFS_CONTROL_MEM_DATA;



/* 錾FMFS_CONTROL_MEM_BUFFER */
typedef struct
{
	MFS_CONTROL_MEM_DATA	mem;
	void 					*buffer;
}MFS_CONTROL_MEM_BUFFER, *PMFS_CONTROL_MEM_BUFFER;


/* ------------------------------------------------------------------ 
   --- variable definition                                        --- 
   ------------------------------------------------------------------ */

pointer   MfsControlEvent_handle;
int_32    mfs_write_file_sel;

MFS_CONTROL_MEM_BUFFER	mfs_control_data[MFS_CONTROL_MEM_MAXSIZE];
MFS_CONTROL_MEM_BUFFER	*mfs_control_mem_start;
MFS_CONTROL_MEM_BUFFER	*mfs_control_mem_end;
MFS_CONTROL_MEM_BUFFER	*pmfs_control_mem_que;
int_16	mfs_control_mem_size;

pointer fd_write_ptr;
pointer fd_read_ptr;
int_32  fileWriteSize;
int_32  fileReadSize;
int_32  fileCount;

/* ------------------------------------------------------------------ 
   --- prototype declaration                                      --- 
   ------------------------------------------------------------------ */

void    *memcpy(void *dest, const void *source, _mem_size n);
void    MFS_control_mem_init(void);
int_32  MFS_control_mem_alloc(MFS_CONTROL_MEM_BUFFER	**pSB);
void    MFS_control_mem_free(MFS_CONTROL_MEM_BUFFER	**ppSB);
int     MFS_control_Set_queue(MFS_CONTROL_MEM_BUFFER	*pnew);
int_32  MFS_control_Get_queue(MFS_CONTROL_MEM_BUFFER	**pget);

void    Mfs_Control_Task(uint_32 temp);
void    MfsControlEvent_Set_SetOpen(int Number);
void    MfsControlEvent_Set_SetClose(void);
void    MfsControlEvent_Set_SetSignalData(uchar* data, int size);
void    MfsControlEvent_Set_GetOpen(int Number);
void    MfsControlEvent_Set_GetClose(void);
void    MfsControlEvent_Set_GetSignalData(uchar* data, int size);
int_32  MfsControl_Get_file_mode(void);
int     effect_recode_Play_stop_func(void);

pointer MFS_control_Rec_Open(int FileNumber);
int     MFS_control_Rec_Close(pointer temp_fd_write_ptr, int FileNumber);
pointer MFS_control_Play_Open(int FileNumber);
int     MFS_control_Play_Close(pointer temp_fd_read_ptr);


/*TASK*-----------------------------------------------------------------
*
* Function Name  : MfsControlEvent_Set_SetOpen
* Returned Value : void
* Comments       : ^p t@COpenCxgʒm
*
*END------------------------------------------------------------------*/
void MfsControlEvent_Set_SetOpen(int Number)
{
	fileCount = Number;
	mfs_write_file_sel = MFS_CONTROL_FILE_WRITE_ING;
	_event_set(MfsControlEvent_handle, MC_EVENT_SET_OPEN);
}


/*TASK*-----------------------------------------------------------------
*
* Function Name  : MfsControlEvent_Set_SetClose
* Returned Value : void
* Comments       : ^p t@CCloseCxgʒm
*
*END------------------------------------------------------------------*/
void MfsControlEvent_Set_SetClose(void)
{
	_event_set(MfsControlEvent_handle, MC_EVENT_SET_CLOSE);
}


/*TASK*-----------------------------------------------------------------
*
* Function Name  : MfsControlEvent_Set_SetSignalData
* Returned Value : void
* Comments       : ^p t@C WRITECxgʒm
*
*END------------------------------------------------------------------*/
void MfsControlEvent_Set_SetSignalData(uchar* data, int size)
{
	int_32	erct;

	static MFS_CONTROL_MEM_BUFFER	*pmfs_control;

	erct = MFS_control_mem_alloc(&pmfs_control);
	if (erct != E_OK){
		printf("pmfs_control buffer busy !!\n");
		return;
	}

	memcpy(&pmfs_control->mem.data[0], data ,size);
	pmfs_control->mem.size = size;

	MFS_control_Set_queue(pmfs_control);

	_event_set(MfsControlEvent_handle, MC_EVENT_SET_SIGNAL_DATA);
}


/*TASK*-----------------------------------------------------------------
*
* Function Name  : MfsControlEvent_Set_GetOpen
* Returned Value : void
* Comments       : Đp t@COpenCxgʒm
*
*END------------------------------------------------------------------*/
void MfsControlEvent_Set_GetOpen(int Number)
{
	fd_read_ptr = MFS_control_Play_Open(Number);
	fileReadSize = 0;
	mfs_write_file_sel = MFS_CONTROL_FILE_READ;
}


/*TASK*-----------------------------------------------------------------
*
* Function Name  : MfsControlEvent_Set_GetClose
* Returned Value : void
* Comments       : Đp t@CCloseCxgʒm
*
*END------------------------------------------------------------------*/
void MfsControlEvent_Set_GetClose(void)
{
	_event_set(MfsControlEvent_handle, MC_EVENT_GET_CLOSE);
}


/*TASK*-----------------------------------------------------------------
*
* Function Name  : MfsControlEvent_Set_GetSignalData
* Returned Value : void
* Comments       :
*
*END------------------------------------------------------------------*/
void MfsControlEvent_Set_GetSignalData(uchar* data, int size)
{
	int fsize;
	if (mfs_write_file_sel == MFS_CONTROL_FILE_READ){
		if (fileReadSize >= MFS_FILE_SIZE_MAX){
			/* Close the file: */
			MFS_control_Play_Close(fd_read_ptr);
			mfs_write_file_sel = MFS_CONTROL_FILE_CLOSE;

			printf("Event MC_EVENT_SET_CLOSE. \n");
		}
		else{
			fsize = read(fd_read_ptr, data, size);

			if (fsize>0){
				printf("*");
				fileReadSize = fileReadSize + size;
			}
			else{
				/* Close the file: */
				MFS_control_Play_Close(fd_read_ptr);
				mfs_write_file_sel = MFS_CONTROL_FILE_CLOSE;

				printf("Event MC_EVENT_SET_CLOSE. \n");

				effect_recode_Play_stop_func();
			}
		}
	}
}


/*TASK*-----------------------------------------------------------------
*
* Function Name  : MfsControl_Get_file_mode
* Returned Value : void
* Comments       :
*
*END------------------------------------------------------------------*/
int_32 MfsControl_Get_file_mode(void)
{
	return mfs_write_file_sel;
}


/*TASK*-----------------------------------------------------------------
*
* Function Name  : Mfs_Control_Task
* Returned Value : void
* Comments       :
*
*END------------------------------------------------------------------*/
void Mfs_Control_Task(uint_32 temp)
{ 
	_mqx_uint         event_result;
	static _mqx_uint  event_bit;
	int_32	ercd;
	static MFS_CONTROL_MEM_BUFFER	*pmfs_control;

	mfs_write_file_sel = MFS_CONTROL_FILE_NO;

	printf("Start Mfs_Control_Task \n");

	fileCount = 0;

	/* MFS control memory  */
	MFS_control_mem_init();

	/* create event - event.Event */
	event_result = _event_create("Mfs_Controlevent.Event");
	if (event_result != MQX_OK) { 
		/* event event.Event not be created */
		printf("Signalevent.Event not be created. \n");
	}

	/* open connection to event event.Event */
	event_result = _event_open("Mfs_Controlevent.Event", &MfsControlEvent_handle);
	if (event_result != MQX_OK) { 
		/* could not open event.Event1  */
		printf("could not open Signalevent.Event. \n");
	}

	/* Run the shell on the serial port */
	for(;;)  {
		/* wait event - event.Event */
		event_result = _event_wait_any( MfsControlEvent_handle, 0x00ff, 0);
		if (event_result != MQX_OK) { 
			/* wait  the event event.Event1 failed */
			printf(" wait the event.Event failed. \n");
		}

		_event_get_value( MfsControlEvent_handle, &event_bit);

		if ((event_bit & MC_EVENT_SET_OPEN) != 0){
			_event_clear( MfsControlEvent_handle, MC_EVENT_SET_OPEN);
			fd_write_ptr = MFS_control_Rec_Open(fileCount);

			fileWriteSize = 0;
			mfs_write_file_sel = MFS_CONTROL_FILE_WRITE;
		}

		if ((event_bit & MC_EVENT_SET_CLOSE) != 0){
			_event_clear( MfsControlEvent_handle, MC_EVENT_SET_CLOSE);

			while(1){
				ercd = MFS_control_Get_queue(&pmfs_control);
				if (ercd != E_OK){
					break;
				}
				else{
					if (mfs_write_file_sel == MFS_CONTROL_FILE_WRITE){
						if (fileWriteSize >= MFS_FILE_SIZE_MAX){
							/* Close the file: */
							MFS_control_Rec_Close(fd_write_ptr, fileCount);
							mfs_write_file_sel = MFS_CONTROL_FILE_CLOSE;

						}
						else{
							ercd = write(fd_write_ptr, &pmfs_control->mem.data[0], pmfs_control->mem.size);
							fileWriteSize = fileWriteSize + pmfs_control->mem.size;
							if (ercd>0){
								printf("*");
							}
							else{
								printf("o");
							}
						}
					}

					MFS_control_mem_free(&pmfs_control);
				}
			}

			if (mfs_write_file_sel == MFS_CONTROL_FILE_WRITE){
				/* Close the file: */
				MFS_control_Rec_Close(fd_write_ptr, fileCount);
				mfs_write_file_sel = MFS_CONTROL_FILE_CLOSE;
			}
		}

		if ((event_bit & MC_EVENT_SET_SIGNAL_DATA) != 0){
			_event_clear( MfsControlEvent_handle, MC_EVENT_SET_SIGNAL_DATA);
			while(1){
				ercd = MFS_control_Get_queue(&pmfs_control);
				if (ercd != E_OK){
					break;
				}
				else{
					if (mfs_write_file_sel == MFS_CONTROL_FILE_WRITE){
						if (fileWriteSize >= MFS_FILE_SIZE_MAX){
							MFS_control_Rec_Close(fd_write_ptr, fileCount);
							mfs_write_file_sel = MFS_CONTROL_FILE_CLOSE;
						}
						else{
							ercd = write(fd_write_ptr, &pmfs_control->mem.data[0], pmfs_control->mem.size);
							fileWriteSize = fileWriteSize + pmfs_control->mem.size;
							if (ercd>0){
								printf("*");
							}
							else{
								printf("o");
							}
						}
					}

					MFS_control_mem_free(&pmfs_control);
				}
			}
		}
	}
}


/*TASK*-----------------------------------------------------------------
*
* Function Name  : MFS_control_Rec_Open
* Returned Value : t@C|C^
* Comments       :
*
*END------------------------------------------------------------------*/
pointer MFS_control_Rec_Open(int FileNumber)
{
	char *filename;

	switch(FileNumber){
		case 0:
			filename = "a:voice.wav";
			break;
		case 1:
			filename = "a:voice1.wav";
			break;
		case 2:
			filename = "a:voice2.wav";
			break;
		case 3:
			filename = "a:voice3.wav";
			break;
	}

	return fopen(filename, "w");
}


/*TASK*-----------------------------------------------------------------
*
* Function Name  : MFS_control_Rec_Close
* Returned Value : 
* Comments       :
*
*END------------------------------------------------------------------*/
int MFS_control_Rec_Close(pointer temp_fd_write_ptr, int FileNumber)
{
	pointer temp_fd_flush_ptr;
	char *filename;

	switch(FileNumber){
		case 0:
			filename = "a:voice.wav";
			break;
		case 1:
			filename = "a:voice1.wav";
			break;
		case 2:
			filename = "a:voice2.wav";
			break;
		case 3:
			filename = "a:voice3.wav";
			break;
	}

	/* Close the file: */
	fclose(temp_fd_write_ptr);
	printf("Event MC_EVENT_SET_CLOSE. \n");

	temp_fd_flush_ptr = fopen(filename, "r");
	fflush(temp_fd_flush_ptr);
	fclose(temp_fd_flush_ptr);

	return 0;
}


/*TASK*-----------------------------------------------------------------
*
* Function Name  : MFS_control_Play_Open
* Returned Value : t@C|C^
* Comments       :
*
*END------------------------------------------------------------------*/
pointer MFS_control_Play_Open(int FileNumber)
{
	char *filename;

	switch(FileNumber){
		case 0:
			filename = "a:voice.wav";
			break;
		case 1:
			filename = "a:voice1.wav";
			break;
		case 2:
			filename = "a:voice2.wav";
			break;
		case 3:
			filename = "a:voice3.wav";
			break;
	}

	return fopen(filename, "r");
}


/*TASK*-----------------------------------------------------------------
*
* Function Name  : MFS_control_Play_Close
* Returned Value : 
* Comments       :
*
*END------------------------------------------------------------------*/
int MFS_control_Play_Close(pointer temp_fd_read_ptr)
{
	/* Close the file: */
	fclose(temp_fd_read_ptr);
	printf("Event MC_EVENT_SET_CLOSE. \n");

	return 0;
}





/* ================================================================================== 
	MFS CONTROL MEMORY
   ================================================================================== */

/*TASK*-----------------------------------------------------------------
*
* Function Name  : MFS_control_mem_init
* Returned Value : void
* Comments       :
*
*END------------------------------------------------------------------*/
void MFS_control_mem_init(void)
{
	int i;

	for (i = 0 ;i < (MFS_CONTROL_MEM_MAXSIZE-1) ; i++){
		mfs_control_data[i].buffer  = (void *)&mfs_control_data[i+1];
	}

	mfs_control_data[MFS_CONTROL_MEM_MAXSIZE-1].buffer  = (void *)0;
	mfs_control_mem_start 	= (MFS_CONTROL_MEM_BUFFER*)&mfs_control_data[0];
	mfs_control_mem_end 	= (MFS_CONTROL_MEM_BUFFER*)&mfs_control_data[(MFS_CONTROL_MEM_MAXSIZE-1)];

	mfs_control_mem_size = 0;
	pmfs_control_mem_que = (MFS_CONTROL_MEM_BUFFER*)0;
}


/*TASK*-----------------------------------------------------------------
*
* Function Name  : MFS_control_mem_alloc
* Returned Value : G[R[h
* Comments       :
*
*END------------------------------------------------------------------*/
int_32 MFS_control_mem_alloc(MFS_CONTROL_MEM_BUFFER	**pSB)
{
	MFS_CONTROL_MEM_BUFFER *pmfs_temp;

	if (mfs_control_mem_start->buffer == 0){
		/* Memory Busy */
		return E_OBJ;
	}

	pmfs_temp = mfs_control_mem_start;
	mfs_control_mem_start = (MFS_CONTROL_MEM_BUFFER*)mfs_control_mem_start->buffer;
	mfs_control_mem_size++;

	pmfs_temp->buffer = 0;
	*pSB  = (MFS_CONTROL_MEM_BUFFER*)pmfs_temp;

	return E_OK;
}


/*TASK*-----------------------------------------------------------------
*
* Function Name  : MFS_control_mem_free
* Returned Value : void
* Comments       :
*
*END------------------------------------------------------------------*/
void MFS_control_mem_free(MFS_CONTROL_MEM_BUFFER	**ppSB)
{
	volatile MFS_CONTROL_MEM_BUFFER	*pSB;

	pSB = (MFS_CONTROL_MEM_BUFFER*)*ppSB;

	mfs_control_mem_end->buffer = (void*)pSB;

	mfs_control_mem_end = (MFS_CONTROL_MEM_BUFFER*)pSB;
	mfs_control_mem_end->buffer = 0;
	mfs_control_mem_size--;
}


/*TASK*-----------------------------------------------------------------
*
* Function Name  : MFS_control_Set_queue
* Returned Value : 
* Comments       :
*
*END------------------------------------------------------------------*/
int MFS_control_Set_queue(MFS_CONTROL_MEM_BUFFER	*pnew)
{
	MFS_CONTROL_MEM_BUFFER	*pWmem;

	if (pmfs_control_mem_que == 0){
		pmfs_control_mem_que = pnew;
	}
	else{
		pWmem = pmfs_control_mem_que;
		while(1){
			if (pWmem->buffer == 0){
				pWmem->buffer = (void*)pnew;
				break;
			}
			pWmem = (MFS_CONTROL_MEM_BUFFER*)pWmem->buffer;
		}
	}

	return E_OK;
}


/*TASK*-----------------------------------------------------------------
*
* Function Name  : MFS_control_Get_queue
* Returned Value : G[R[h
* Comments       :
*
*END------------------------------------------------------------------*/
int_32 MFS_control_Get_queue(MFS_CONTROL_MEM_BUFFER	**pget)
{
	if (pmfs_control_mem_que == 0){
		return E_OBJ;
	}

	*pget  = pmfs_control_mem_que;

	if (pmfs_control_mem_que->buffer == 0){
		pmfs_control_mem_que = 0;
	}
	else{
		pmfs_control_mem_que = pmfs_control_mem_que->buffer;
	}

	return E_OK;
}




/* EOF */
