;*HEADER********************************************************************
;* 
;* Copyright (c) 2008 Freescale Semiconductor;
;* All Rights Reserved                       
;*
;* Copyright (c) 1989-2008 ARC International;
;* All Rights Reserved
;*
;*************************************************************************** 
;*
;* THIS SOFTWARE IS PROVIDED BY FREESCALE "AS IS" AND ANY EXPRESSED OR 
;* IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
;* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  
;* IN NO EVENT SHALL FREESCALE OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
;* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
;* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
;* SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
;* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
;* STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
;* IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
;* THE POSSIBILITY OF SUCH DAMAGE.
;*
;**************************************************************************
;*
;* $FileName: types.cw$
;* $Version : 3.0.6.0$
;* $Date    : May-20-2009$
;*
;* Comments:
;*
;*   This file contains the assembler offsets calculated by the
;*   program KRNL_OFF.C.  These offsets are to be included in
;*   any assembler program that wishes to access kernel data
;*   structures.
;*
;*END***********************************************************************


;
; 'PSP_INT_CONTEXT_STRUCT' size = 12 , 0xc
;
IC_STRUCT_SIZE                      .equ   12  ;  0xc
IC_ERROR_CODE                       .equ    0  ;  0x0
IC_ENABLE_SR                        .equ    4  ;  0x4
IC_PREV_CONTEXT                     .equ    8  ;  0x8


;
; 'INTERRUPT_TABLE_STRUCT' size = 12 , 0xc
;
IT_STRUCT_SIZE                      .equ   12  ;  0xc
IT_APP_ISR                          .equ    0  ;  0x0
IT_APP_ISR_EXCEPTION_HANDLER        .equ    4  ;  0x4
IT_APP_ISR_DATA                     .equ    8  ;  0x8

HASH_ISR_ITM_SIZE                   .equ    16
HASH_ISR_NUM                        .equ    0
HASH_ISR_ADDR                       .equ    4
HASH_ISR_DATA                       .equ    8
HASH_ISR_NEXT                       .equ    12

;
; 'READY_Q_STRUCT' size = 16 , 0x10
;
RQ_STRUCT_SIZE                      .equ   16  ;  0x10
RQ_HEAD_READY_Q                     .equ    0  ;  0x0
RQ_TAIL_READY_Q                     .equ    4  ;  0x4
RQ_NEXT_Q                           .equ    8  ;  0x8
RQ_ENABLE_SR                        .equ   12  ;  0xc
RQ_PRIORITY                         .equ   14  ;  0xe


;
; 'TD_STRUCT' size = 216 , 0xd8
;
TD_TD_NEXT                          .equ    0  ;  0x0
TD_TD_PREV                          .equ    4  ;  0x4
TD_STATE                            .equ    8  ;  0x8
TD_TASK_ID                          .equ   12  ;  0xc
TD_STACK_BASE                       .equ   16  ;  0x10
TD_STACK_PTR                        .equ   20  ;  0x14
TD_STACK_LIMIT                      .equ   24  ;  0x18
TD_MY_QUEUE                         .equ   28  ;  0x1c
TD_HOME_QUEUE                       .equ   32  ;  
TD_TASK_SR                          .equ   36  ;  
TD_RESERVED1                        .equ   38  ;  
TD_FLAGS                            .equ   42  ;  

;
; 'KERNEL_DATA_STRUCT' size = 1156 , 0x484
;
;KD_ADDRESSING_CAPABILITY            .equ    0  ;  0x0
;KD_ENDIANESS                        .equ    4  ;  0x4
;KD_CPU_TYPE                         .equ    8  ;  0x8
;KD_PSP_CFG_MEMORY_ALIGNMENT         .equ   10  ;  0xa
;KD_PSP_CFG_STACK_ALIGNMENT          .equ   12  ;  0xc
;KD_PSP_CFG_MEM_STOREBLOCK_ALIGNMENT .equ   14  ;  0xe
;KD_CONFIG1                          .equ   16  ;  0x10
KD_CONFIG2                          .equ   18  ;  0x12
KD_FLAGS                            .equ   20  ;  0x14
KD_DISABLE_SR                       .equ   22  ;  0x16
KD_IN_ISR                           .equ   24  ;  0x18
KD_ACTIVE_SR                        .equ   26  ;  0x1a
KD_ACTIVE_PTR                       .equ   28  ;  0x1c
KD_READY_Q_LIST                     .equ   32  ;  0x28
KD_CURRENT_READY_Q                  .equ   36  ;  0x2c
KD_DEFAULT_ISR                      .equ  40  ;  
KD_FIRST_USER_ISR_VECTOR            .equ  44  ;  
KD_LAST_USER_ISR_VECTOR             .equ  48  ;  
KD_INTERRUPT_CONTEXT_PTR            .equ  52  ;  
KD_INTERRUPT_TABLE_PTR              .equ  56  ;
KD_INTERRUPT_STACK_PTR              .equ  60  ; 
.if MQX_KERNEL_LOGGING
KD_LOG_CONTROL                      .equ  64
LOG_OLD_TD                          .equ  68
KD_SYSTEM_TD                        .equ  72
.else
KD_SYSTEM_TD                        .equ  64
.endif





;
; 'PSP_BLOCKED_FP_STRUCT'
FP_FPCR_OFFSET                      .equ 0     ; 0x00
FP_FPSR_OFFSET                      .equ 4     ; 0x04
FP_FPIAR_OFFSET                     .equ 8     ; 0x08
FP_TID_OFFSET                       .equ 12    ; 0x0C
FP_FPR0_OFFSET                      .equ 16    ; 0x10
FP_FPR1_OFFSET                      .equ 24    ; 0x18
FP_FPR2_OFFSET                      .equ 32    ; 0x20
FP_FPR3_OFFSET                      .equ 40    ; 0x28
FP_FPR4_OFFSET                      .equ 48    ; 0x30
FP_FPR5_OFFSET                      .equ 56    ; 0x38
FP_FPR6_OFFSET                      .equ 64    ; 0x40
FP_FPR7_OFFSET                      .equ 72    ; 0x48

;* EOF
