/**HEADER********************************************************************
* 
* Copyright (c) 2008 Freescale Semiconductor;
* All Rights Reserved                       
*
*************************************************************************** 
*
* THIS SOFTWARE IS PROVIDED BY FREESCALE "AS IS" AND ANY EXPRESSED OR 
* IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  
* IN NO EVENT SHALL FREESCALE OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
* SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
* STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
* IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
* THE POSSIBILITY OF SUCH DAMAGE.
*
**************************************************************************
*
* $FileName: usbprv_dev.h$
* $Version : 3.0.3.0$
* $Date    : Mar-11-2009$
*
* Comments:
*
*   This file contains the private defines, externs and data structure 
*   definitions required by the MCF522XX USB Device driver.
*
*END************************************************************************/

#ifndef __usbprv_dev_h__
#define __usbprv_dev_h__ 1

#include "usb_dev_types.h"

#define USB_XD_QADD(head,tail,XD)           \
   if ((head) == NULL) {                    \
      (head) = (XD);                        \
   } else {                                 \
      (tail)->SCRATCH_PTR->PRIVATE = (XD);  \
   } /* Endif */                            \
   (tail) = (XD);                           \
   (XD)->SCRATCH_PTR->PRIVATE = NULL
   
#define USB_XD_QGET(head,tail,XD)   \
   (XD) = (head);                   \
   if (head) {                      \
      (head) = (XD_STRUCT_PTR)((head)->SCRATCH_PTR->PRIVATE);  \
      if ((head) == NULL) {         \
         (tail) = NULL;             \
      } /* Endif */                 \
   } /* Endif */

#include "mcf522xx_dev_main.h"

/***************************************
**
** Prototypes
**
*/
#ifdef __cplusplus
extern "C" {
#endif

#ifdef __cplusplus
}
#endif

#endif